From f9ef226b7e37bada0e9afead46bd8378962b92aa Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Tue, 6 Aug 2013 02:29:50 -0400
Subject: [PATCH] Refactored CLI framework.

Some common CLI methods and attributes have been refactored into the CLI base
class. A new SubsystemCLI class was added as the base for subsystem CLI
modules. The MainCLI was modified such that it will only perform authentication
if the subsystem is specified in the server URI. If no subsystem is specified
in the URI, the authentication will be done by the subsystem CLI module.

Ticket #701
---
 .../src/com/netscape/cmstools/cert/CertCLI.java    | 35 +++-----
 .../com/netscape/cmstools/cert/CertFindCLI.java    | 12 +--
 .../com/netscape/cmstools/cert/CertHoldCLI.java    | 16 ++--
 .../netscape/cmstools/cert/CertReleaseHoldCLI.java | 16 ++--
 .../netscape/cmstools/cert/CertRequestFindCLI.java | 13 +--
 .../cmstools/cert/CertRequestReviewCLI.java        | 26 +++---
 .../netscape/cmstools/cert/CertRequestShowCLI.java | 12 +--
 .../cmstools/cert/CertRequestSubmitCLI.java        | 18 ++---
 .../com/netscape/cmstools/cert/CertRevokeCLI.java  | 18 ++---
 .../com/netscape/cmstools/cert/CertShowCLI.java    | 12 +--
 .../src/com/netscape/cmstools/cli/CLI.java         | 79 ++++++++++++++++++-
 .../src/com/netscape/cmstools/cli/MainCLI.java     | 21 ++---
 .../SubsystemCLI.java}                             | 50 +++++++-----
 .../src/com/netscape/cmstools/cli/TPSCLI.java      | 92 ++++++----------------
 .../com/netscape/cmstools/client/ClientCLI.java    | 34 +++-----
 .../cmstools/client/ClientFindCertCLI.java         | 16 ++--
 .../cmstools/client/ClientImportCertCLI.java       | 20 ++---
 .../cmstools/client/ClientRemoveCertCLI.java       | 14 ++--
 .../com/netscape/cmstools/group/GroupAddCLI.java   | 12 +--
 .../netscape/cmstools/group/GroupAddMemberCLI.java | 12 +--
 .../src/com/netscape/cmstools/group/GroupCLI.java  | 34 +++-----
 .../com/netscape/cmstools/group/GroupFindCLI.java  | 12 +--
 .../cmstools/group/GroupFindMemberCLI.java         | 12 +--
 .../netscape/cmstools/group/GroupModifyCLI.java    | 12 +--
 .../netscape/cmstools/group/GroupRemoveCLI.java    | 12 +--
 .../cmstools/group/GroupRemoveMemberCLI.java       | 12 +--
 .../com/netscape/cmstools/group/GroupShowCLI.java  | 12 +--
 .../cmstools/group/GroupShowMemberCLI.java         | 12 +--
 .../src/com/netscape/cmstools/key/KeyCLI.java      | 35 +++-----
 .../src/com/netscape/cmstools/key/KeyFindCLI.java  | 12 +--
 .../netscape/cmstools/key/KeyRequestFindCLI.java   | 12 +--
 .../netscape/cmstools/profile/ProfileAddCLI.java   | 13 +--
 .../com/netscape/cmstools/profile/ProfileCLI.java  | 38 +++------
 .../cmstools/profile/ProfileDisableCLI.java        | 12 +--
 .../cmstools/profile/ProfileEnableCLI.java         | 12 +--
 .../netscape/cmstools/profile/ProfileFindCLI.java  | 12 +--
 .../cmstools/profile/ProfileModifyCLI.java         | 12 +--
 .../cmstools/profile/ProfileRemoveCLI.java         | 12 +--
 .../netscape/cmstools/profile/ProfileShowCLI.java  | 14 ++--
 .../cmstools/system/KRAConnectorAddCLI.java        | 13 +--
 .../netscape/cmstools/system/KRAConnectorCLI.java  | 37 +++------
 .../cmstools/system/KRAConnectorRemoveCLI.java     | 13 +--
 .../cmstools/system/SecurityDomainCLI.java         | 37 +++------
 .../system/SecurityDomainGetInstallTokenCLI.java   | 12 +--
 .../cmstools/system/SecurityDomainShowCLI.java     | 12 +--
 .../src/com/netscape/cmstools/token/TokenCLI.java  | 79 ++++---------------
 .../src/com/netscape/cmstools/user/UserAddCLI.java | 12 +--
 .../com/netscape/cmstools/user/UserAddCertCLI.java | 12 +--
 .../cmstools/user/UserAddMembershipCLI.java        | 12 +--
 .../src/com/netscape/cmstools/user/UserCLI.java    | 35 +++-----
 .../com/netscape/cmstools/user/UserFindCLI.java    | 12 +--
 .../netscape/cmstools/user/UserFindCertCLI.java    | 12 +--
 .../cmstools/user/UserFindMembershipCLI.java       | 12 +--
 .../com/netscape/cmstools/user/UserModifyCLI.java  | 12 +--
 .../com/netscape/cmstools/user/UserRemoveCLI.java  | 12 +--
 .../netscape/cmstools/user/UserRemoveCertCLI.java  | 12 +--
 .../cmstools/user/UserRemoveMembershipCLI.java     | 12 +--
 .../com/netscape/cmstools/user/UserShowCLI.java    | 12 +--
 .../netscape/cmstools/user/UserShowCertCLI.java    | 12 +--
 59 files changed, 553 insertions(+), 659 deletions(-)
 copy base/java-tools/src/com/netscape/cmstools/{user/UserRemoveMembershipCLI.java => cli/SubsystemCLI.java} (52%)

diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java
index 8abe6f22ad64a3f43b84b782051f166b82cdbbf3..9b69c992ca0e87d6491f108b00d69b1fc96627ef 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java
@@ -21,7 +21,6 @@ package com.netscape.cmstools.cert;
 import java.text.SimpleDateFormat;
 import java.util.Arrays;
 
-import org.apache.commons.lang.StringUtils;
 import org.jboss.resteasy.plugins.providers.atom.Link;
 
 import com.netscape.certsrv.cert.CertClient;
@@ -39,12 +38,10 @@ public class CertCLI extends CLI {
 
     public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
 
-    public MainCLI parent;
-    public CertClient client;
+    public CertClient certClient;
 
-    public CertCLI(MainCLI parent) {
-        super("cert", "Certificate management commands");
-        this.parent = parent;
+    public CertCLI(CLI parent) {
+        super("cert", "Certificate management commands", parent);
 
         addModule(new CertFindCLI(this));
         addModule(new CertShowCLI(this));
@@ -58,30 +55,18 @@ public class CertCLI extends CLI {
         addModule(new CertRequestReviewCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
-        client = new CertClient(parent.client);
+        certClient = new CertClient(parent.getClient());
 
         if (args.length == 0) {
             printHelp();
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java
index 590d7959866740a5adbfa74c75f8cdebada6672f..7f8eb75f1c8576e8972190eac32b4fa407d85d47 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertFindCLI.java
@@ -41,15 +41,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class CertFindCLI extends CLI {
 
-    public CertCLI parent;
+    public CertCLI certCLI;
 
-    public CertFindCLI(CertCLI parent) {
-        super("find", "Find certificates");
-        this.parent = parent;
+    public CertFindCLI(CertCLI certCLI) {
+        super("find", "Find certificates", certCLI);
+        this.certCLI = certCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -120,7 +120,7 @@ public class CertFindCLI extends CLI {
 
         CertDataInfos certs = null;
         try {
-            certs = parent.client.findCerts(searchData, start, size);
+            certs = certCLI.certClient.findCerts(searchData, start, size);
         } catch (PKIException e) {
             System.err.println("Error: Cannot list certificates. " + e.getMessage());
             System.exit(1);
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java
index b6b5fcde73a5eefb8b44912044a589f5fe99bee6..2ebdb0ecf466fb76ec8d204dc65857ac3f9cf945 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertHoldCLI.java
@@ -39,15 +39,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class CertHoldCLI extends CLI {
 
-    public CertCLI parent;
+    public CertCLI certCLI;
 
-    public CertHoldCLI(CertCLI parent) {
-        super("hold", "Place certificate on-hold");
-        this.parent = parent;
+    public CertHoldCLI(CertCLI certCLI) {
+        super("hold", "Place certificate on-hold", certCLI);
+        this.certCLI = certCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Serial Number> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Serial Number> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -77,7 +77,7 @@ public class CertHoldCLI extends CLI {
         }
 
         CertId certID = new CertId(cmdArgs[0]);
-        CertData certData = parent.client.reviewCert(certID);
+        CertData certData = certCLI.certClient.reviewCert(certID);
 
         if (!cmd.hasOption("force")) {
 
@@ -101,7 +101,7 @@ public class CertHoldCLI extends CLI {
         request.setComments(cmd.getOptionValue("comments"));
         request.setNonce(certData.getNonce());
 
-        CertRequestInfo certRequestInfo = parent.client.revokeCert(certID, request);
+        CertRequestInfo certRequestInfo = certCLI.certClient.revokeCert(certID, request);
 
         if (verbose) {
             CertCLI.printCertRequestInfo(certRequestInfo);
@@ -116,7 +116,7 @@ public class CertHoldCLI extends CLI {
                 MainCLI.printMessage("Could not place certificate \"" + certID.toHexString() + "\" on-hold");
             } else {
                 MainCLI.printMessage("Placed certificate \"" + certID.toHexString() + "\" on-hold");
-                certData = parent.client.getCert(certID);
+                certData = certCLI.certClient.getCert(certID);
                 CertCLI.printCertData(certData, false, false);
             }
         } else {
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java
index 5158505390286221e0572995626ed1524664404f..aa58539b84ec751507da849c9e4a43a49713f10c 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertReleaseHoldCLI.java
@@ -36,15 +36,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class CertReleaseHoldCLI extends CLI {
 
-    public CertCLI parent;
+    public CertCLI certCLI;
 
-    public CertReleaseHoldCLI(CertCLI parent) {
-        super("release-hold", "Place certificate off-hold");
-        this.parent = parent;
+    public CertReleaseHoldCLI(CertCLI certCLI) {
+        super("release-hold", "Place certificate off-hold", certCLI);
+        this.certCLI = certCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Serial Number> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Serial Number> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -73,7 +73,7 @@ public class CertReleaseHoldCLI extends CLI {
 
         if (!cmd.hasOption("force")) {
 
-            CertData certData = parent.client.getCert(certID);
+            CertData certData = certCLI.certClient.getCert(certID);
 
             System.out.println("Placing certificate off-hold:");
 
@@ -91,7 +91,7 @@ public class CertReleaseHoldCLI extends CLI {
 
         CertUnrevokeRequest request = new CertUnrevokeRequest();
 
-        CertRequestInfo certRequestInfo = parent.client.unrevokeCert(certID, request);
+        CertRequestInfo certRequestInfo = certCLI.certClient.unrevokeCert(certID, request);
 
         if (verbose) {
             CertCLI.printCertRequestInfo(certRequestInfo);
@@ -106,7 +106,7 @@ public class CertReleaseHoldCLI extends CLI {
                 MainCLI.printMessage("Could not place certificate \"" + certID.toHexString() + "\" off-hold");
             } else {
                 MainCLI.printMessage("Placed certificate \"" + certID.toHexString() + "\" off-hold");
-                CertData certData = parent.client.getCert(certID);
+                CertData certData = certCLI.certClient.getCert(certID);
                 CertCLI.printCertData(certData, false, false);
             }
         } else {
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
index fe54e70898f47e6c14301d8cffabd6e531874cc4..dbfc0ee87c40a96ee11526a200955852f652de73 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
@@ -33,15 +33,16 @@ import com.netscape.cmstools.cli.MainCLI;
  * @author Ade Lee
  */
 public class CertRequestFindCLI extends CLI {
-    public CertCLI parent;
 
-    public CertRequestFindCLI(CertCLI parent) {
-        super("request-find", "Find certificate requests");
-        this.parent = parent;
+    public CertCLI certCLI;
+
+    public CertRequestFindCLI(CertCLI certCLI) {
+        super("request-find", "Find certificate requests", certCLI);
+        this.certCLI = certCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -82,7 +83,7 @@ public class CertRequestFindCLI extends CLI {
         if (requestType != null && requestType.equals("all")) requestType = null;
 
         try {
-            certRequests = parent.client.certRequestResource.listRequests(requestState, requestType, start, size, maxResults, maxTime);
+            certRequests = certCLI.certClient.certRequestResource.listRequests(requestState, requestType, start, size, maxResults, maxTime);
         } catch (PKIException e) {
             System.err.println("Error: Cannot list certificate requests. " + e.getMessage());
             System.exit(-1);
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java
index 3891508bd99baf231bd107154add691dcadba3c6..d303b2edb59b844adee919af2aab080cad537eea 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestReviewCLI.java
@@ -24,19 +24,19 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class CertRequestReviewCLI extends CLI {
 
-    CertCLI parent;
+    CertCLI certCLI;
     List<String> actions = Arrays.asList(
         "approve", "reject", "cancel", "update", "validate", "assign", "unassign"
     );
 
-    public CertRequestReviewCLI(CertCLI parent) {
-        super("request-review", "Review certificate request");
-        this.parent = parent;
+    public CertRequestReviewCLI(CertCLI certCLI) {
+        super("request-review", "Review certificate request", certCLI);
+        this.certCLI = certCLI;
     }
 
     @Override
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Request ID> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Request ID> [OPTIONS...]", options);
     }
 
     @Override
@@ -96,7 +96,7 @@ public class CertRequestReviewCLI extends CLI {
         // Retrieve certificate request.
         CertReviewResponse reviewInfo = null;
         try {
-            reviewInfo = parent.client.reviewRequest(requestId);
+            reviewInfo = certCLI.certClient.reviewRequest(requestId);
         } catch (PKIException e) {
             System.err.println(e.getMessage());
             System.exit(-1);
@@ -135,31 +135,31 @@ public class CertRequestReviewCLI extends CLI {
         }
 
         if (action.equalsIgnoreCase("approve")) {
-            parent.client.approveRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.approveRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Approved certificate request " + requestId);
 
         } else if (action.equalsIgnoreCase("reject")) {
-            parent.client.rejectRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.rejectRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Rejected certificate request " + requestId);
 
         } else if (action.equalsIgnoreCase("cancel")) {
-            parent.client.cancelRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.cancelRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Canceled certificate request " + requestId);
 
         } else if (action.equalsIgnoreCase("update")) {
-            parent.client.updateRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.updateRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Updated certificate request " + requestId);
 
         } else if (action.equalsIgnoreCase("validate")) {
-            parent.client.validateRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.validateRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Validated certificate request " + requestId);
 
         } else if (action.equalsIgnoreCase("assign")) {
-            parent.client.assignRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.assignRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Assigned certificate request " + requestId);
 
         } else if (action.equalsIgnoreCase("unassign")) {
-            parent.client.unassignRequest(reviewInfo.getRequestId(), reviewInfo);
+            certCLI.certClient.unassignRequest(reviewInfo.getRequestId(), reviewInfo);
             MainCLI.printMessage("Unassigned certificate request " + requestId);
 
         } else {
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java
index edabb2296db130c866605ef281d58b3e32420094..ca8fcb25cc893726232dec7deb803af838127494 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java
@@ -10,16 +10,16 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class CertRequestShowCLI extends CLI {
 
-    CertCLI parent;
+    CertCLI certCLI;
 
-    public CertRequestShowCLI(CertCLI parent) {
-        super("request-show", "Show certificate request");
-        this.parent = parent;
+    public CertRequestShowCLI(CertCLI certCLI) {
+        super("request-show", "Show certificate request", certCLI);
+        this.certCLI = certCLI;
     }
 
     @Override
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Request ID>", options);
+        formatter.printHelp(getFullName() + " <Request ID>", options);
     }
 
     @Override
@@ -49,7 +49,7 @@ public class CertRequestShowCLI extends CLI {
             System.exit(-1);
         }
 
-        CertRequestInfo certRequest = parent.client.getRequest(requestId);
+        CertRequestInfo certRequest = certCLI.certClient.getRequest(requestId);
 
         MainCLI.printMessage("Certificate request \"" + requestId + "\"");
         CertCLI.printCertRequestInfo(certRequest);
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestSubmitCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestSubmitCLI.java
index 3562d48f0206ebaecdc919563688043d1e0848e9..917a697b6dee5a15a69ca69dce0c9118b96fc228 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestSubmitCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestSubmitCLI.java
@@ -19,11 +19,15 @@ import com.netscape.cmstools.cli.MainCLI;
 
 public class CertRequestSubmitCLI extends CLI {
 
-    CertCLI parent;
+    CertCLI certCLI;
 
-    public CertRequestSubmitCLI(CertCLI parent) {
-        super("request-submit", "Submit certificate request");
-        this.parent = parent;
+    public CertRequestSubmitCLI(CertCLI certCLI) {
+        super("request-submit", "Submit certificate request", certCLI);
+        this.certCLI = certCLI;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(getFullName() + " <filename>", options);
     }
 
     @Override
@@ -50,7 +54,7 @@ public class CertRequestSubmitCLI extends CLI {
 
         try {
             erd = getEnrollmentRequest(cLineArgs[0]);
-            CertRequestInfos cri = parent.client.enrollRequest(erd);
+            CertRequestInfos cri = certCLI.certClient.enrollRequest(erd);
             MainCLI.printMessage("Submitted certificate request");
             printRequestInformation(cri);
         } catch (FileNotFoundException e) {
@@ -78,8 +82,4 @@ public class CertRequestSubmitCLI extends CLI {
         }
         System.out.println();
     }
-
-    public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <filename>", options);
-    }
 }
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRevokeCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRevokeCLI.java
index 8727655f51373d7e34af38932ce487e5a509d0fa..49ec889e2771321440af34001e158c45ee9787fa 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRevokeCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRevokeCLI.java
@@ -39,15 +39,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class CertRevokeCLI extends CLI {
 
-    public CertCLI parent;
+    public CertCLI certCLI;
 
-    public CertRevokeCLI(CertCLI parent) {
-        super("revoke", "Revoke certificate");
-        this.parent = parent;
+    public CertRevokeCLI(CertCLI certCLI) {
+        super("revoke", "Revoke certificate", certCLI);
+        this.certCLI = certCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Serial Number> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Serial Number> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -105,7 +105,7 @@ public class CertRevokeCLI extends CLI {
             return;
         }
 
-        CertData certData = parent.client.reviewCert(certID);
+        CertData certData = certCLI.certClient.reviewCert(certID);
 
         if (!cmd.hasOption("force")) {
 
@@ -138,9 +138,9 @@ public class CertRevokeCLI extends CLI {
         CertRequestInfo certRequestInfo;
 
         if (cmd.hasOption("ca")) {
-            certRequestInfo = parent.client.revokeCACert(certID, request);
+            certRequestInfo = certCLI.certClient.revokeCACert(certID, request);
         } else {
-            certRequestInfo = parent.client.revokeCert(certID, request);
+            certRequestInfo = certCLI.certClient.revokeCert(certID, request);
         }
 
         if (verbose) {
@@ -163,7 +163,7 @@ public class CertRevokeCLI extends CLI {
                     MainCLI.printMessage("Revoked certificate \"" + certID.toHexString() + "\"");
                 }
 
-                certData = parent.client.getCert(certID);
+                certData = certCLI.certClient.getCert(certID);
                 CertCLI.printCertData(certData, false, false);
             }
         } else {
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertShowCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertShowCLI.java
index 798514814efde6ecbd72333d4961d25bd7c781fa..d1d6132ae597baeb00ad124d1e96e9756e4f87b6 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertShowCLI.java
@@ -34,15 +34,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class CertShowCLI extends CLI {
 
-    public CertCLI parent;
+    public CertCLI certCLI;
 
-    public CertShowCLI(CertCLI parent) {
-        super("show", "Show certificate");
-        this.parent = parent;
+    public CertShowCLI(CertCLI certCLI) {
+        super("show", "Show certificate", certCLI);
+        this.certCLI = certCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Serial Number> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Serial Number> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -78,7 +78,7 @@ public class CertShowCLI extends CLI {
         CertId certID = new CertId(cmdArgs[0]);
         String file = cmd.getOptionValue("output");
 
-        CertData certData = parent.client.getCert(certID);
+        CertData certData = certCLI.certClient.getCert(certID);
 
         String encoded = certData.getEncoded();
         if (encoded != null && file != null) {
diff --git a/base/java-tools/src/com/netscape/cmstools/cli/CLI.java b/base/java-tools/src/com/netscape/cmstools/cli/CLI.java
index 40ac517af761e90789fe624598e466f5a9aa7b14..ecece0a09203b477e829d745da41f39a12c52509 100644
--- a/base/java-tools/src/com/netscape/cmstools/cli/CLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cli/CLI.java
@@ -25,6 +25,9 @@ import org.apache.commons.cli.CommandLineParser;
 import org.apache.commons.cli.HelpFormatter;
 import org.apache.commons.cli.Options;
 import org.apache.commons.cli.PosixParser;
+import org.apache.commons.lang.StringUtils;
+
+import com.netscape.certsrv.client.PKIClient;
 
 
 /**
@@ -37,14 +40,15 @@ public class CLI {
     public static CommandLineParser parser = new PosixParser();
     public static HelpFormatter formatter = new HelpFormatter();
 
-    public CLI parent;
-
     public String name;
     public String description;
+    public CLI parent;
 
     public Options options = new Options();
     public Map<String, CLI> modules = new LinkedHashMap<String, CLI>();
 
+    public PKIClient client;
+
     public CLI(String name, String description) {
         this(name, description, null);
     }
@@ -87,10 +91,79 @@ public class CLI {
         return modules.get(name);
     }
 
-    public void execute(String[] args) throws Exception {
+    public PKIClient getClient() {
+        return client;
+    }
+
+    public Object getClient(String name) {
+        return null;
     }
 
     public void printHelp() {
+
+        System.out.println("Commands:");
+
+        int leftPadding = 1;
+        int rightPadding = 25;
+
+        for (CLI module : modules.values()) {
+            String label = getFullName() + "-" + module.getName();
+
+            int padding = rightPadding - leftPadding - label.length();
+            if (padding < 1)
+                padding = 1;
+
+            System.out.print(StringUtils.repeat(" ", leftPadding));
+            System.out.print(label);
+            System.out.print(StringUtils.repeat(" ", padding));
+            System.out.println(module.getDescription());
+        }
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        if (args.length == 0) {
+            printHelp();
+            System.exit(1);
+        }
+
+        String command = args[0];
+        String moduleName;
+        String moduleCommand;
+
+        // If a command contains a '-' sign it will be
+        // split into module name and module command.
+        // Otherwise it's a single command.
+        int i = command.indexOf('-');
+        if (i >= 0) { // <module name>-<module command>
+            moduleName = command.substring(0, i);
+            moduleCommand = command.substring(i+1);
+
+        } else { // <command>
+            moduleName = command;
+            moduleCommand = null;
+        }
+
+        // get command module
+        if (verbose) System.out.println("Module: " + moduleName);
+        CLI module = getModule(moduleName);
+        if (module == null) {
+            throw new Error("Invalid module \"" + moduleName + "\".");
+        }
+
+        // prepare module arguments
+        String[] moduleArgs;
+        if (moduleCommand != null) {
+            moduleArgs = new String[args.length];
+            moduleArgs[0] = moduleCommand;
+            System.arraycopy(args, 1, moduleArgs, 1, args.length-1);
+
+        } else {
+            moduleArgs = new String[args.length-1];
+            System.arraycopy(args, 1, moduleArgs, 0, args.length-1);
+        }
+
+        module.execute(moduleArgs);
     }
 
     public static boolean isVerbose() {
diff --git a/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java b/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java
index 257f0bcfbd5418c2cc8332c13ce287fb7748817c..7625e2f47b34b2114a5537f46bdfbc96fe227a39 100644
--- a/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cli/MainCLI.java
@@ -60,8 +60,6 @@ public class MainCLI extends CLI {
 
     public File certDatabase;
 
-    public PKIClient client;
-    public PKIConnection connection;
     public AccountClient accountClient;
 
     String output;
@@ -275,7 +273,7 @@ public class MainCLI extends CLI {
         client = new PKIClient(config);
         client.setVerbose(verbose);
 
-        connection = client.getConnection();
+        PKIConnection connection = client.getConnection();
         connection.setRejectedCertStatuses(rejectedCertStatuses);
         connection.setIgnoredCertStatuses(ignoredCertStatuses);
 
@@ -285,7 +283,12 @@ public class MainCLI extends CLI {
             connection.setOutput(file);
         }
 
-        accountClient = new AccountClient(client);
+        String subsystem = config.getSubsystem();
+        if (subsystem != null) {
+            // if server URI includes subsystem, perform authentication
+            // against that subsystem
+            accountClient = new AccountClient(client, subsystem);
+        }
     }
 
     public void execute(String[] args) throws Exception {
@@ -374,14 +377,13 @@ public class MainCLI extends CLI {
         if (verbose) System.out.println("Server URI: "+config.getServerURI());
 
         // execute command
-        boolean loggedIn = false;
         try {
             init();
 
-            // login if username or nickname is specified
-            if (config.getUsername() != null || config.getCertNickname() != null) {
+            // login if subsystem and username/nickname is specified
+            if (config.getSubsystem() != null &&
+                    (config.getUsername() != null || config.getCertNickname() != null)) {
                 accountClient.login();
-                loggedIn = true;
             }
 
             // execute module command
@@ -396,7 +398,8 @@ public class MainCLI extends CLI {
             System.exit(1);
 
         } finally {
-            if (loggedIn) accountClient.logout();
+            // logout if subsystem is specified
+            if (config.getSubsystem() != null) accountClient.logout();
         }
     }
 
